import jp.jig.jiglet.*;

/*
----------------------------------------------------------------------
 StringCalc jiglet
                                      Copyright (C) 2008 jiglet.info
----------------------------------------------------------------------
 version 0.0.5 (2008/07/31)
----------------------------------------------------------------------
̃vOThe MIT Licenseɏ]Ĕzz܂B
----------------------------------------------------------------------
The MIT License

Copyright (c) 2006-2008 jiglet.info
Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is 
furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in 
all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
THE SOFTWARE.
----------------------------------------------------------------------
*/

public class StringCalc extends Jiglet {
	String answer;
	StringBuffer baseDigits, inputDigits, lastInputDigits;
	char operator = 0, lastOperator;
	int charsAfterDot = 30;  /* _ȉ̌ */
	int state = 0;           /* 0:̐l 1:E̐l 2:񓚕\ */
	boolean calculating = false;
	boolean isAllClear = true;
	char[] opes;
	
	public void paint(boolean allDrawFlag) {
		draw3DRect(0, 0, DW, DH);
		
		setFont(FONT_SMALL);
		setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
		
		StringBuffer drawsb = new StringBuffer();
		if (baseDigits != null) {
			if (baseDigits.toString().length() == 0) {
				drawsb.append("0");
			} else {
				drawsb.append(baseDigits.toString());
			}
		} else {
			drawsb.append("0");
		}
		if (operator > 0) {
			drawsb.append(' ');
			drawsb.append(operator);
		}
		if (inputDigits != null) {
			drawsb.append(' ');
			drawsb.append(inputDigits.toString());
		}
		if (answer != null) {
			drawsb.append("  ");
			drawsb.append(answer);
		}
		String drawst = drawsb.toString();
		
		for (int st = 0, nx, y = getFontHeight(); st < drawst.length(); ) {
			nx = getLineBreak(drawst, st, drawst.length() - st, DW - (getFontHeight() / 2));
			drawString(drawst.substring(st, nx), (getFontHeight() / 4), y);
			st = nx;
			y += getFontHeight();
		}
		
		draw3DButton(0, DH - getFontHeight() * 7 / 2, DW, (getFontHeight() * 7 / 2));
		setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
		if (calculating) {
			drawString("vZł...", (getFontHeight() / 4), DH - (getFontHeight() * 9 / 4));
			drawString("@@...̂܂܂΂炭҂", (getFontHeight() / 4), DH - (getFontHeight() * 5 / 4));
		} else {
			drawString("@~@ | :vZJn", (getFontHeight() / 4), DH - (getFontHeight() * 9 / 4));
			drawString("|{ | L[Ől", (getFontHeight() / 4), DH - (getFontHeight() * 5 / 4));
			drawString("@@ | *ŃRs[ / #ŏ_", (getFontHeight() / 4), DH - (getFontHeight() / 4));
		}
	}
	
	public void main() {
		baseDigits = new StringBuffer();
		
		/* Ȃ '|'  "|".charAt(0) vȂւ̑Ώorz */
		opes = new char[] {
			("{".charAt(0)),
			("|".charAt(0)),
			("~".charAt(0)),
			("".charAt(0)),
			("O".charAt(0)),
		};
		
		setMenu(new String[] {
			"ׂ",
		}, new String[] {
			"ׂA܂͗ݏBĹuOv",
		});
		
		setSoftLabel("I");
		for (;;) {
			repaint();
			int key = getKey();
			if ((key & EVENT_MENU) > 0) {
				// j[̑ICxg
				doMenuEvent(key & 0xffff);
				continue;
			}
			switch (key) {
				case KEY_SELECT:
					/* vZJn */
					calc();
					break;
				case KEY_RIGHT:
					/* Z */
					if ((state == 1) && (inputDigits.toString().length() > 0)) {
						calc();
					}
					if (state == 2) {
						baseDigits = new StringBuffer();
						baseDigits.append(answer);
						answer = null;
					}
					operator = opes[0];
					inputDigits = new StringBuffer();
					state = 1;
					setSoftLabel("AC");
					break;
				case KEY_LEFT:
					/* Z */
					if ((state == 1) && (inputDigits.toString().length() > 0)) {
						calc();
					}
					if (state == 2) {
						baseDigits = new StringBuffer();
						baseDigits.append(answer);
						answer = null;
					}
					operator = opes[1];
					inputDigits = new StringBuffer();
					state = 1;
					setSoftLabel("AC");
					break;
				case KEY_UP:
					/* Z */
					if ((state == 1) && (inputDigits.toString().length() > 0)) {
						calc();
					}
					if (state == 2) {
						baseDigits = new StringBuffer();
						baseDigits.append(answer);
						answer = null;
					}
					operator = opes[2];
					inputDigits = new StringBuffer();
					state = 1;
					setSoftLabel("AC");
					break;
				case KEY_DOWN:
					/* Z */
					if ((state == 1) && (inputDigits.toString().length() > 0)) {
						calc();
					}
					if (state == 2) {
						baseDigits = new StringBuffer();
						baseDigits.append(answer);
						answer = null;
					}
					operator = opes[3];
					inputDigits = new StringBuffer();
					state = 1;
					setSoftLabel("AC");
					break;
				case KEY_IAPP:
					/* NA */
					if (answer != null) {
						answer = null;
						inputDigits = null;
						baseDigits = new StringBuffer();
						operator = 0;
						state = 0;
						setSoftLabel("I");
					} else if ((inputDigits != null) && (inputDigits.toString().length() > 0)) {
						inputDigits = new StringBuffer();
						state = 1;
					} else if (operator > 0) {
						operator = 0;
						state = 0;
					} else {
						baseDigits = new StringBuffer();
						state = 0;
						setSoftLabel("I");
					}
					break;
				case KEY_SOFT:
					/* I[NA */
					if ((state == 0) && (baseDigits.toString().equals("") || baseDigits.toString().equals("0"))) {
						terminate();
					}
					answer = null;
					inputDigits = null;
					baseDigits = new StringBuffer();
					operator = 0;
					state = 0;
					setSoftLabel("I");
					break;
				case KEY_0:
				case KEY_1:
				case KEY_2:
				case KEY_3:
				case KEY_4:
				case KEY_5:
				case KEY_6:
				case KEY_7:
				case KEY_8:
				case KEY_9:
					if (state == 2) {
						answer = null;
						inputDigits = null;
						baseDigits = new StringBuffer();
						operator = 0;
						state = 0;
					}
					if (state == 1) {
						inputDigits.append("" + (key - KEY_0));
					} else if (state == 0) {
						baseDigits.append("" + (key - KEY_0));
					}
					setSoftLabel("AC");
					break;
				case KEY_POUND:
					/* #L[ŏ_ */
					if (state == 1) {
						if (inputDigits.toString().indexOf(".") < 0) {
							if (inputDigits.toString().length() == 0) {
								inputDigits.append("0");
							}
							inputDigits.append(".");
						}
					} else if (state == 0) {
						if (baseDigits.toString().indexOf(".") < 0) {
							if (baseDigits.toString().length() == 0) {
								baseDigits.append("0");
							}
							baseDigits.append(".");
						}
					}
					break;
				case KEY_ASTERISK:
					StringBuffer sb = new StringBuffer();
					if (baseDigits != null) {
						if (baseDigits.toString().length() == 0) {
							sb.append("0");
						} else {
							sb.append(baseDigits.toString());
						}
					} else {
						sb.append("0");
					}
					if (operator > 0) {
						sb.append(' ');
						sb.append(operator);
					}
					if (inputDigits != null) {
						sb.append(' ');
						sb.append(inputDigits.toString());
					}
					if (answer != null) {
						sb.append("  ");
						sb.append(answer);
					}
					inputText(sb.toString(), TEXT_ALPHA);
					break;
				default:
				//	continue;
			}
		}
	}
	void doMenuEvent(int menuID) {
		switch (menuID) {
			case 0:
				/* ׂ */
				if ((state == 1) && (inputDigits.toString().length() > 0)) {
					calc();
				}
				if (state == 2) {
					baseDigits = new StringBuffer();
					baseDigits.append(answer);
					answer = null;
				}
				operator = opes[4];
				inputDigits = new StringBuffer();
				state = 1;
				setSoftLabel("AC");
				break;
			default:
		}
	}
	void calc() {
		if (state == 0) {
			return;
		}
		if (inputDigits.toString().length() == 0) {
			inputDigits = baseDigits;
		}
		
		if (state == 2) {
			baseDigits = new StringBuffer();
			baseDigits.append(answer);
			answer = null;
			inputDigits = lastInputDigits;
			operator = lastOperator;
		}
		
		calculating = true;
		repaint();
		
		if (operator == opes[0]) {
			answer = calcPlus(baseDigits.toString(), inputDigits.toString());
		} else if (operator == opes[1]) {
			answer = calcMinus(baseDigits.toString(), inputDigits.toString());
		} else if (operator == opes[2]) {
			answer = calcMultiple(baseDigits.toString(), inputDigits.toString());
		} else if (operator == opes[3]) {
			answer = calcDivision(baseDigits.toString(), inputDigits.toString());
		} else if (operator == opes[4]) {
			answer = calcPower(baseDigits.toString(), inputDigits.toString());
		}
		lastInputDigits = inputDigits;
		lastOperator = operator;
		state = 2;
		
		gc();
		calculating = false;
		repaint();
	}
	
	int getIntOfDigit(String in, int pos, boolean posIsReverse) {
		char digit;
		if (pos >= in.length()) {
			digit = '0';
		} else {
			digit = in.charAt(posIsReverse ? (in.length() - pos - 1) : pos);
		}
		switch ((int)digit) {
			case (int)'0':
				return(0);
			case (int)'1':
				return(1);
			case (int)'2':
				return(2);
			case (int)'3':
				return(3);
			case (int)'4':
				return(4);
			case (int)'5':
				return(5);
			case (int)'6':
				return(6);
			case (int)'7':
				return(7);
			case (int)'8':
				return(8);
			case (int)'9':
				return(9);
		}
		return(0);
	}
	String convNegaPosi(String in) {
		if (in.startsWith("-")) {
			return(in.substring(1));
		}
		return("-" + in);
	}
	
	String calcReverse(String in) {
		StringBuffer ret = new StringBuffer();
		boolean skippingZero = true;
		for (int i = 0; i < in.length(); i++) {
			if (skippingZero && (in.charAt(in.length() - i - 1) == '0')) {
				continue;
			}
			ret.append(in.charAt(in.length() - i - 1));
			skippingZero = false;
		}
		if (skippingZero) {
			return("0");
		}
		return(ret.toString());
	}
	
	boolean calcIsALarge(String numA, String numB) {
		if (numA.length() < numB.length()) {
			/* B̂ق(傫)Ƃ́AltO𗧂ĂABꂩ */
			return(false);
		} else {
			/* ͓Âقꍇ */
			if (numA.length() == numB.length()) {
				/* ꍇ͌ */
				for (int pos = 0; pos < numA.length(); pos++) {
					int intA = getIntOfDigit(numA, pos, false);
					int intB = getIntOfDigit(numB, pos, false);
					if (intA < intB) {
						/* 擪猩āAB̌̂ق傫ȂƂB̂ق傫 */
						return(false);
					} else if (intA > intB) {
						/* tɁAǍ̂ق傫ȂƂÂق傫 */
						return(true);
					}
				}
			}
		}
		return(true);
	}
	String cleanNum(String num) {
		if (num.indexOf(".") < 0) {
			/* ̏ꍇ͂̂܂ܕԂ */
			return(num);
		}
		for (int i = (num.length() - 1); i >= 0; i--) {
			if (num.charAt(i) == '.') {
				return(num.substring(0, i));
			}
			if (num.charAt(i) != '0') {
				return(num.substring(0, i + 1));
			}
		}
		/* ܂ŗ̂́Au.0000v݂Ȃ̂ */
		return("0");
	}
	String cleanNumFront(String num) {
		for (int i = 0; i < num.length(); i++) {
			if (num.charAt(i) == '.') {
				return("0" + num.substring(i));
			}
			if (num.charAt(i) != '0') {
				return(num.substring(i));
			}
		}
		/* ܂ŗ̂́Au0000v݂Ȃ̂ */
		return("0");
	}
	
	String calcPlus(String numA, String numB) {
		if ((numA.startsWith("-")) && (numB.startsWith("-"))) {
			/* }CiXm͐Βl̘aɃ}CiXL(vXm̘aZ̓}CiXɂ͂ȂȂ) */
			return("-" + calcPlus(numA.substring(1), numB.substring(1)));
		}
		if (numA.startsWith("-")) {
			/* }CiXvX͍EꂩăvX}CiXɂ */
			String tmp = numA;
			numA = numB;
			numB = tmp;
		}
		if (numB.startsWith("-")) {
			/* vX}CiX͈Zɕϊ */
			return(calcMinus(numA, numB.substring(1)));
		}
		
		if ((numA.indexOf(".") >= 0) || (numB.indexOf(".") >= 0)) {
			/* ꍇ́AƏɕāǍ킹AČvZA_ݒu */
			String numAInt, numAFra, numBInt, numBFra, retInt;
			if (numA.indexOf(".") >= 0) {
				numAInt = numA.substring(0, numA.indexOf("."));
				numAFra = numA.substring(numA.indexOf(".") + 1);
			} else {
				numAInt = numA;
				numAFra = "0";
			}
			if (numB.indexOf(".") >= 0) {
				numBInt = numB.substring(0, numB.indexOf("."));
				numBFra = numB.substring(numB.indexOf(".") + 1);
			} else {
				numBInt = numB;
				numBFra = "0";
			}
			
			if (numAFra.length() > numBFra.length()) {
				for (int i = 0, max = numAFra.length() - numBFra.length(); i < max; i++) {
					numBFra = numBFra + "0";
				}
			} else {
				for (int i = 0, max = numBFra.length() - numAFra.length(); i < max; i++) {
					numAFra = numAFra + "0";
				}
			}
			
			retInt = calcPlus(numAInt + numAFra, numBInt + numBFra);
			return(cleanNum(retInt.substring(0, retInt.length() - numAFra.length()) + "." + retInt.substring(retInt.length() - numAFra.length())));
		}
		
		int max;
		StringBuffer ret = new StringBuffer();
		
		if (numA.length() > numB.length()) {
			max = numA.length();
		} else {
			max = numB.length();
		}
		
		int kari = 0;
		for (int pos = 0; pos < max; pos++) {
			int tmpCalc = getIntOfDigit(numA, pos, true) + getIntOfDigit(numB, pos, true) + kari;
			ret.append("" + (tmpCalc % 10));
			kari = (tmpCalc - (tmpCalc % 10)) / 10;
		}
		while (kari > 0) {
			ret.append("" + (kari % 10));
			kari = (kari - (kari % 10)) / 10;
		}
		
		return(	calcReverse(ret.toString()));
	}
	
	String calcMinus(String numA, String numB) {
		if ((numA.startsWith("-")) && (numB.startsWith("-"))) {
			/* }CiXm̓}CiXΒlɕϊ */
			return(calcPlus(numA, numB.substring(1)));
		}
		if (numA.startsWith("-")) {
			/* }CiXvX͐Βlm̑Z̕]ɕϊ */
			return(convNegaPosi(calcPlus(numA.substring(1), numB)));
		}
		if (numB.startsWith("-")) {
			/* vX}CiX͑Zɕϊ */
			return(calcPlus(numA, numB.substring(1)));
		}
		
		if ((numA.indexOf(".") >= 0) || (numB.indexOf(".") >= 0)) {
			/* ꍇ́AƏɕāǍ킹AČvZA_ݒu */
			String numAInt, numAFra, numBInt, numBFra, retInt;
			if (numA.indexOf(".") >= 0) {
				numAInt = numA.substring(0, numA.indexOf("."));
				numAFra = numA.substring(numA.indexOf(".") + 1);
			} else {
				numAInt = numA;
				numAFra = "0";
			}
			if (numB.indexOf(".") >= 0) {
				numBInt = numB.substring(0, numB.indexOf("."));
				numBFra = numB.substring(numB.indexOf(".") + 1);
			} else {
				numBInt = numB;
				numBFra = "0";
			}

			if (numAFra.length() > numBFra.length()) {
				for (int i = 0, max = numAFra.length() - numBFra.length(); i < max; i++) {
					numBFra = numBFra + "0";
				}
			} else {
				for (int i = 0, max = numBFra.length() - numAFra.length(); i < max; i++) {
					numAFra = numAFra + "0";
				}
			}

			retInt = calcMinus(numAInt + numAFra, numBInt + numBFra);
			{
				boolean haveToNegative = retInt.startsWith("-");
				if (haveToNegative) {
					retInt = retInt.substring(1);
				}
				for (int i = 0, max = numAFra.length() - retInt.length(); i < max; i++) {
					retInt = "0" + retInt;
				}
				retInt = retInt.substring(0, retInt.length() - numAFra.length()) + "." + retInt.substring(retInt.length() - numAFra.length());
				if (retInt.startsWith(".")) {
					retInt = "0" + retInt;
				}
				if (haveToNegative) {
					retInt = "-" + retInt;
				}
			}
			return(cleanNum(retInt));
		}
		
		int max;
		StringBuffer ret = new StringBuffer();
		boolean haveToNegative = false;
		
		if (calcIsALarge(numA, numB)) {
			max = numA.length();
		} else {
			max = numB.length();
			haveToNegative = true;
			String tmp = numA;
			numA = numB;
			numB = tmp;
		}

		int kari = 0;
		for (int pos = 0; pos < max; pos++) {
			int tmpCalc = getIntOfDigit(numA, pos, true) - getIntOfDigit(numB, pos, true) - kari;
			String debugtmp = "Pos" + pos + " : " + getIntOfDigit(numA, pos, true) + " - " + getIntOfDigit(numB, pos, true) + " - " + kari + " = " + tmpCalc;
			for (kari = 0; tmpCalc < 0; ) {
				tmpCalc += 10;
				kari++;
			}
			ret.append("" + tmpCalc);
		}
		if (kari != 0) {
			println("vZG[? : " + kari);
		}
		
		if (haveToNegative) {
			return(convNegaPosi(calcReverse(ret.toString())));
		} else {
			return(calcReverse(ret.toString()));
		}
	}
	
	String calcMultiple(String numA, String numB) {
		if ((numA.startsWith("-")) && (numB.startsWith("-"))) {
			/* }CiXm̓vXmƓ */
			numA = numA.substring(1);
			numB = numB.substring(1);
		}
		
		boolean haveToNegative = false;
		if ((numA.startsWith("-")) || (numB.startsWith("-"))) {
			/* ǂ炩}CiXȂAʂ̓}CiX */
			haveToNegative = true;
			if (numA.startsWith("-")) {
				numA = numA.substring(1);
			} else {
				numB = numB.substring(1);
			}
		}

		if ((numA.indexOf(".") >= 0) || (numB.indexOf(".") >= 0)) {
			/* ꍇ́AƏɕāǍ킹AČvZA_ݒu */
			String numAInt, numAFra, numBInt, numBFra, retInt;
			if (numA.indexOf(".") >= 0) {
				numAInt = numA.substring(0, numA.indexOf("."));
				numAFra = numA.substring(numA.indexOf(".") + 1);
			} else {
				numAInt = numA;
				numAFra = "0";
			}
			if (numB.indexOf(".") >= 0) {
				numBInt = numB.substring(0, numB.indexOf("."));
				numBFra = numB.substring(numB.indexOf(".") + 1);
			} else {
				numBInt = numB;
				numBFra = "0";
			}

			if (numAFra.length() > numBFra.length()) {
				for (int i = 0, max = numAFra.length() - numBFra.length(); i < max; i++) {
					numBFra = numBFra + "0";
				}
			} else {
				for (int i = 0, max = numBFra.length() - numAFra.length(); i < max; i++) {
					numAFra = numAFra + "0";
				}
			}

			retInt = calcMultiple(numAInt + numAFra, numBInt + numBFra);
			{
				haveToNegative = retInt.startsWith("-");
				if (haveToNegative) {
					retInt = retInt.substring(1);
				}
				for (int i = 0, max = (numAFra.length() * 2) - retInt.length(); i < max; i++) {
					retInt = "0" + retInt;
				}
				retInt = retInt.substring(0, retInt.length() - (numAFra.length() * 2)) + "." + retInt.substring(retInt.length() - (numAFra.length() * 2));
				if (retInt.startsWith(".")) {
					retInt = "0" + retInt;
				}
				if (haveToNegative) {
					retInt = "-" + retInt;
				}
			}
			return(cleanNum(retInt));
		}

		String ret = "0";
		for (int dig = 0; dig < numB.length(); dig++) {
			StringBuffer calc = new StringBuffer();
			for (int i = 0; i < dig; i++) {
				calc.append("0");
			}
			int kari = 0;
			for (int pos = 0; pos < numA.length(); pos++) {
				int tmpCalc = getIntOfDigit(numA, pos, true) * getIntOfDigit(numB, dig, true) + kari;
				calc.append("" + (tmpCalc % 10));
				kari = (tmpCalc - (tmpCalc % 10)) / 10;
			}
			while (kari > 0) {
				calc.append("" + (kari % 10));
				kari = (kari - (kari % 10)) / 10;
			}
			
			ret = calcPlus(ret, calcReverse(calc.toString()));
		}
		
		if (haveToNegative) {
			return(convNegaPosi(ret));
		} else {
			return(ret);
		}
	}

	String calcDivision(String numA, String numB) {
		{
			boolean ok = false;
			for (int i = 0; i < numB.length(); i++) {
				if (numB.charAt(i) != '0') {
					ok = true;
					break;
				}
			}
			if (! ok) {
				/* Div by Zero(₱̂)[ԂƂɂ */
				return("0");
			}
		}
		
		if ((numA.startsWith("-")) && (numB.startsWith("-"))) {
			/* }CiXm̓vXmƓ */
			numA = numA.substring(1);
			numB = numB.substring(1);
		}
		
		boolean haveToNegative = false;
		if ((numA.startsWith("-")) || (numB.startsWith("-"))) {
			/* ǂ炩}CiXȂAʂ̓}CiX */
			haveToNegative = true;
			if (numA.startsWith("-")) {
				numA = numA.substring(1);
			} else {
				numB = numB.substring(1);
			}
		}
		
		if ((numA.indexOf(".") >= 0) || (numB.indexOf(".") >= 0)) {
			/* ꍇ́A(_ړ҂10^n{)珬_Ȃ */
			String numAInt, numAFra, numBInt, numBFra, retInt;
			if (numA.indexOf(".") >= 0) {
				numAInt = numA.substring(0, numA.indexOf("."));
				numAFra = numA.substring(numA.indexOf(".") + 1);
			} else {
				numAInt = numA;
				numAFra = "0";
			}
			if (numB.indexOf(".") >= 0) {
				numBInt = numB.substring(0, numB.indexOf("."));
				numBFra = numB.substring(numB.indexOf(".") + 1);
			} else {
				numBInt = numB;
				numBFra = "0";
			}

			if (numAFra.length() > numBFra.length()) {
				for (int i = 0, max = numAFra.length() - numBFra.length(); i < max; i++) {
					numBFra = numBFra + "0";
				}
			} else {
				for (int i = 0, max = numBFra.length() - numAFra.length(); i < max; i++) {
					numAFra = numAFra + "0";
				}
			}

			numA = numAInt + numAFra;
			numB = numBInt + numBFra;
		}
		
		/* _ȉ charsAfterDot܂ */
		
		StringBuffer ret = new StringBuffer();
		StringBuffer kari = new StringBuffer();
		for (int digID = 0, fraDigits = 0; /*digID < numA.length() + charsAfterDot*/; digID++) {
			StringBuffer calc = new StringBuffer();
			/* ̐u~낷v */
			if (digID < numA.length()) {
				kari.append(numA.substring(digID, digID + 1));
			} else {
				if (kari.toString().equals("0") || kari.toString().equals("")) {
					/* _߂iKŁA]肪[ȂI */
					break;
				}
				kari.append("0");
				if (fraDigits > 0) {
					fraDigits++;
					if (fraDigits > charsAfterDot) {
						/* _ȉ̌ꍇI */
						ret.append("c");
						break;
					}
				} else {
					fraDigits = 1;
					ret.append(".");
				}
			}
			
			/* 鐔̕鐔傫Ȃ܂ŁuĂv𑝂₷ */
			int digit = 1;
			String tmp = numB;
			String tmp2 = "0";
			String tmpKari = kari.toString();
			while (calcIsALarge(tmpKari, tmp)) {
				digit++;
				if (digit > 10) {
					/* ̎_10z遁cH (10̏ꍇ́A9̂OK) */
					return("");
				}
				tmp2 = tmp;
				tmp = calcMultiple(numB, "" + digit);
			}
			/* ̎_ 0 <= digit <= 9 ł邱Ƃۏ؂Ă */
			ret.append("" + (digit - 1));
			kari = new StringBuffer();
			tmp = calcMinus(tmpKari, tmp2);
			if (! tmp.equals("0")) {
				kari.append(tmp);
			}
		}
		
		if (haveToNegative) {
			return(convNegaPosi(cleanNumFront(ret.toString())));
		} else {
			return(cleanNumFront(ret.toString()));
		}
	}

	String calcPower(String numA, String numB) {
		/* ׂ */
		if (numB.equals("0")) {
			/* 01Ƃ݂Ȃ */
			return "1";
		}
		if (numB.startsWith("-")) {
			/* w}CiX̏ꍇ0ɂ */
			return "0";
		}

		boolean isMinus = false;
		if (numA.startsWith("-")) {
			switch ((int)numB.charAt(numB.length() - 1)) {
				case (int)'1':
				case (int)'3':
				case (int)'5':
				case (int)'7':
				case (int)'9':
					isMinus = true;
			}
			numA = numA.substring(1);
		}

		/* wƂďnꂽꍇA_ȉ͖ */
		{
			int pos;
			if ((pos = numB.indexOf(".")) >= 0) {
				numB = numB.substring(0, pos);
			}
		}

		Object cacheList = new Object[] { numA, "1", null };
		String tmpTimes = "1";

		/* numA2n悪numB𒴂܂Ŋg */
		while (calcIsALarge(numB, tmpTimes = calcMultiple(tmpTimes, "2"))) {
			/* tmpTimes * 2 <= numB */
			cacheList = new Object[] { calcMultiple((String)((Object[])cacheList)[0], (String)((Object[])cacheList)[0]), tmpTimes, cacheList };
		}

		String tmpEvalHold = "0";
		String tmpEvalWork;
		String retAnswer = "1";
		Object tmpPointer = cacheList;
		while (tmpPointer != null) {
			/* QƂԉ */
			/* uw̍vvnumBƂȂׂ[v܂킵Ă */
			tmpEvalWork = calcPlus(tmpEvalHold, (String)((Object[])tmpPointer)[1]);
			if (calcIsALarge(numB, tmpEvalWork)) {
				/* w̍v܂numB̂ق傫 */
				tmpEvalHold = tmpEvalWork;
				retAnswer = calcMultiple(retAnswer, (String)((Object[])tmpPointer)[0]);
			}
			tmpPointer = ((Object[])tmpPointer)[2];
		}

		return (isMinus ? "-" : "") + retAnswer;
	}
}
